Procedure DrawFlatPoly16(poly:TPolygonPtr; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon: array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

{$I src\include\flatscan.pas}

var hsize:longint;
    temp,x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin
      asm
        cld
        {calculate offset of first point}
        mov edi,dword ptr Where
        mov edx,x
        mov ecx,hsize
        add edx,offs


        {fill color}
        mov ax,color
        mov bx,ax
        shl eax,16
        mov ax,bx

        lea edi,[edi+edx*2]

{$IFDEF ALIGN_SCAN}
        {fill horizontal line}
        mov edx,edi
        mov bl,0 {clear flag}
        shr edx,1      {is address word aligned?}
        jnc @@NonOddAddress     {yes, go and fill from non-odd address}
        {Suxx!! address is odd!}
        stosw              {now address is non-odd}
        dec ecx      {substract this putted word from counter}
        jz @@done2   {if there was only one word, exit from here}
@@NonOddAddress:
        shr ecx,1        {is some words here?}
        jnc @@FillWithDWord  {ok, no words left here}
        {O-Ow, one word here}
        {save flag, so we must put it at the and}
        mov bl,1
        jcxz @@done

@@FillWithDWord:
        {check address for dwords}
        shr edx,1
        jnc @@CoolForDwords  {cool, dwords begin at non-odd address!!}
        {it's non-dword aligned address}
        stosw
        dec ecx
        jz @@skip1
        rep stosd
@@skip1:
        stosw
        {ok, we finished on this}
        jmp @@Done   {go out from here}

@@CoolForDWords:
        {wow, put all dwords here!}
        rep stosd

@@done:
        cmp bl,1  {we must put our first word?}
        jne @@done2 {no, go out from here}
        stosw {put it here}
@@done2:
{$ELSE}
        shr ecx,1
        jnc @@1
        stosw
@@1:    rep stosd
{$ENDIF}
      end;
   end;
   offs+:=Where.SizeX;
--   LeftSectionSize:=LeftSectionSize-1;
--   RightSectionSize:=RightSectionSize-1;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else
--      CurrLeftX:=CurrLeftX+LeftStepX;
        CurrLeftX+:=LeftStepX;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else
--      CurrRightX:=CurrRightX+RightStepX;
        CurrRightX+:=RightStepX;

until false;
end;

Procedure DrawTransparentFlatPoly16(poly:TPolygonPtr; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon: array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
{ !!NOTE!! For 15&16 bit modes transparency table not needed}
{ This procedure gives 50% transparency }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

{$I src\include\flatscan.pas}

var hsize:longint;
    temp,x:fixed;
    AndMask:word;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin
      asm
        cld
        {calculate offset of first point}
        mov edi,dword ptr Where
        mov edx,x
        mov ecx,hsize
        add edx,offs

        mov ax,_ColorAndMask
        mov si,ax
        mov bx,color          {put color in ebx register}
        shl esi,16
        mov si,ax

        mov ax,bx
        shl ebx,16
        mov bx,ax

        lea edi,[edi+edx*2]
        shr ebx,1    {divide color by 2}
        and ebx,esi  {clear hi-order bit's of each color component}

{$IFDEF ALIGN_SCAN}
        {fill horizontal line}
        mov edx,edi
        mov dh,0 {clear flag}
        shr dl,1      {is address word aligned?}
        jnc @@NonOddAddress     {yes, go and fill from non-odd address}
        {Suxx!! address is odd!}
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosw              {now address is non-odd}
        dec ecx      {substract this putted word from counter}
        jz @@done2   {if there was only one word, exit from here}
@@NonOddAddress:
        shr ecx,1        {is some words here?}
        jnc @@FillWithDWord  {ok, no words left here}
        {O-Ow, one word here}
        {save flag, so we must put it at the and}
        mov dh,1
        jcxz @@done

@@FillWithDWord:
        {check address for dwords}
        shr dl,1
        jnc @@CoolForDwords  {cool, dwords begin at non-odd address!!}
        {it's non-dword aligned address}
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosw
        dec ecx
        jz @@skip1
@@nextDWord:
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosd
        dec ecx
        jnz @@nextDWord
@@skip1:
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosw
        {ok, we finished on this}
        jmp @@Done   {go out from here}

@@CoolForDWords:
        {wow, put all dwords here!}
@@nextDWord2:
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosd
        dec ecx
        jnz @@nextDWord2
@@done:
        cmp dh,1  {we must put our first word?}
        jne @@done2 {no, go out from here}
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosw {put it here}
@@done2:
{$ELSE}
        shr ecx,1
        jnc @@1
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosw
        jcxz @@done
@@1:
        mov eax,[edi]
        shr eax,1
        and eax,esi
        add eax,ebx
        stosd
        dec ecx
        jnz @@1
@@done:
{$ENDIF}
      end;
   end;
   offs+:=Where.SizeX;
--   LeftSectionSize:=LeftSectionSize-1;
--   RightSectionSize:=RightSectionSize-1;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else
--      CurrLeftX:=CurrLeftX+LeftStepX;
        CurrLeftX+:=LeftStepX;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else
--      CurrRightX:=CurrRightX+RightStepX;
        CurrRightX+:=RightStepX;

until false;
end;
