(**************************************************************)
(*                                                            *)
(*     This is including file for SVGALIB 1.0                 *)
(*  This module designed for fastest possible graphics works  *)
(*  It consist of texture mapping, polygon filling and        *)
(*  shading routines.                                         *)
(*                                                            *)
(*  Copyrights 1998, Uvarov Dmitry                            *)
(*                                                            *)
(**************************************************************)

Var
    PTranspTable:pointer;
{
 NOTE: All drawing polygons must be convex.
   -------             ---------              --------
  /        \            \        \            |      |
/            \            \        \          |  /\  |
\            /            /        /          | /  \ |
  \        /             /       /            |/    \|
    ------              --------
   convex               concave                concave
But here is on exeption: second polygon will be drawn currectly, because
  there is only 2 sides on one scan line
}
{$I src\clip.pas}
{$I src\flat.pas}
{$I src\flat16.pas}
{$I src\goraud.pas}
{$I src\goraud16.pas}
{$I src\txtmap.pas}
{$I src\txtmap16.pas}
{$I src\txtarb.pas}

Procedure LoadTransparencyTable(Table:TTranspTablePtr);
 begin
   PTranspTable:=table;
 end;

Procedure SetClipWindow(x1,y1,x2,y2:integer);
 begin
    ClipTop:=y1*65536;
    ClipBot:=y2*65536;
    ClipLeft:=x1*65536;
    ClipRight:=x2*65536;
 end;

{$IFDEF Z_CLIPPING}
Procedure SetZClippingRange(MinZ,MaxZ:integer);
 begin
    MinZClip:=MinZ*65536;
    MaxZClip:=MaxZ*65536;
 end;
{$ENDIF}
