{The texture inner loop looks like this:                                       }
{        ͻ                           }
{         UPPER 16BIT         LOWER 16BIT                 lea edi,[edi+ecx] }
{͹         neg ecx           }
{  REG     HI WORD      HI BYTE      LO BYTE      @@inner:                }
{͹         mov al,[ebx]      }
{  EAX   Curr-X frac      ---          ---              add edx,ebp       }
{͹         adc bh,dh         }
{  ECX       ---       Scan Line Width                   add eax,esi       }
{͹         adc bl,dl         }
{  EDX   Curr-Y frac  Y-int step    X-int step          mov [edi+ecx],al  }
{͹         inc ecx           }
{  EBP   Y-frac step      ---          ---              jnz @@inner       }
{͹                           }
{  EBX   Texture ptr   Curr-Y int   Curr-X int                            }
{͹                           }
{  ESI   X-frac step      ---          ---                                }
{͹                           }
{  EDI             Destination pointer                                      }
{ͼ                           }
{                                                                              }
{ Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)            }
{ Only pointer to texture in texture record is used                            }

Procedure RenderTexture8(poly:TPolygonPtr; txt:TTexture; Num:byte; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

    prestep:fixed;

{$I src\include\txtscan.pas}

var hsize:longint;
    width:fixed;
    temp:fixed;
    x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      width:=CurrRightX-CurrLeftX;
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);
      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      asm
         mov ebx,dword ptr Txt  -- get texture pointer
         mov ecx,hsize

         mov bl,byte ptr [CurrTextX+2]
         mov edx, CurrTextY
         mov bh,byte ptr [CurrTextY+2]
         shl edx,16

         mov dl,byte ptr [TextStepX+2]
         mov esi,TextStepX      --   mov si,xloadd
         mov dh,byte ptr [TextStepY+2]
         shl esi,16

         mov eax,CurrTextX      --   mov ax,xlo
         mov edi,dword ptr Where  -- get destination segment
         shl eax,16
         add edi,offs
         add edi,x

push ebp
         mov ebp,TextStepY      --   mov bp,yloadd
         shl ebp,16

         -- put first byte --

         shr ecx,1
         jnc @@skipOne

         mov al,[ebx]
         add edx,ebp
         adc bh,dh
         add eax,esi
         adc bl,dl
         mov [edi],al
         inc edi
         jcxz @@done   -- if no more pixels in this line then exit

    @@skipOne:
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
    @@inner:
         -- calc first pixel --
         add edx,ebp
         mov al,[ebx]
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- calc second pixel --
         add edx,ebp
         mov ah,[ebx]
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- put both pixels --
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner
@@done:
pop ebp
      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
   end;

until false;
end;

(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)

Procedure RenderLambertTexture8(poly:TPolygonPtr; txt:TTexture; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - Adding color for texture polygons. Color wrapping not supported,}
{          i.e. if after adding color to first pixel, and it will be overflow,}
{          then it will affect on second color }
{ !!NOTE!! Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

--    prestep:fixed;

{$I src\include\txtscan.pas}

var hsize:longint;
    width:fixed;
    temp:fixed;
    x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
   asm
     mov al,byte ptr color
     mov byte ptr [color+1],al
   end;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      width:=CurrRightX-CurrLeftX;
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;

      asm
         mov ebx,dword ptr Txt  -- get texture pointer
         mov ecx,hsize

         mov bl,byte ptr [CurrTextX+2]
         mov edx, CurrTextY  -- mov dx,ylo
         mov bh,byte ptr [CurrTextY+2]
         shl edx,16

         mov dl,byte ptr [TextStepX+2]
         mov esi,TextStepX      --   mov si,xloadd
         mov dh,byte ptr [TextStepY+2]
         shl esi,16

         mov edi,dword ptr Where  -- get destination segment
         mov eax,CurrTextX      --   mov ax,xlo
         add edi,offs
         shl eax,16
         add edi,x

mov temp,esp       -- save esp register in temporary variable
         mov esp,TextStepY      --  change ebp register to esp
         shl esp,16

         -- put first byte --

         shr ecx,1
         jnc @@skipOne

         mov al,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl
         add al,byte ptr color
    @@ColorAdd1:
         mov [edi],al
         inc edi
         jcxz @@done   -- if no more pixels in this line then exit

    @@skipOne:
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
    @@inner:
         -- calc first pixel --
         mov al,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- calc second pixel --
         mov ah,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- put both pixels --
         add ax,color     { add constant color here }
    @@ColorAdd:
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner
@@done:
--pop ebp
mov esp,temp
      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
   end;

until false;
end;

{ Goraud inner loop is modified and looks like this:                        }
{         lea edi,[edi+ecx]                                                 }
{         xor ecx,-1                                                        }
{         inc ecx                                                           }
{    @@inner:                                                               }
{         mov al,[ebx]                                                      }
{         add edx,esp                         -- yfrac+:=yfrac_step         }
{         adc bh,dh                           -- yint+:=yint_step           }
{         add eax,XFracStep                   -- xfrac+:=xfrac_step         }
{         adc bl,dl                           -- xint+:=xint_step           }
{         add esi,ColorStepInv                -- colorfrac+:=colorfrac_step }
{         adc ah,byte ptr ColorStepInv        -- colorint+:=colorint_step   }
{         add al,ah                           -- TextColor+:=ColoInt        }
{         mov [edi+ecx],al                                                  }
{         inc ecx                                                           }
{         jnz @@inner                                                       }

Procedure RenderGoraudTexture8(poly:TPolygonPtr; txt:TTexture; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - Adding color for texture polygons. Color wrapping not supported,}
{          i.e. if after adding color to first pixel, and it will be overflow,}
{          then it will affect on second color }
{ !!NOTE!! Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;
    ColorStep,LeftColor,RightColor,LeftColorStep,RightColorStep:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
--    MinY,MaxY:fixed;
    offs:dword;

--    prestep:fixed;
    BaseColor:fixed;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      {divide xlen by ylen}
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrLeftX:=Poly^[vrtx1].x+mFixedMul(prestep,LeftStepX);

      CurrLeftTextX:=Poly^[vrtx1].u;
      CurrLeftTextY:=Poly^[vrtx1].v;
      LeftTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrLeftTextX,height);
      LeftTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrLeftTextY,height);

      LeftColor:=Poly^[vrtx1].color;
      LeftColorStep:=mFixedDiv(Poly^[vrtx2].color-LeftColor,height);
      LeftColor+:=BaseColor;
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      {divide xlen by ylen}

      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrRightX:=Poly^[vrtx1].x+mFixedMul(prestep,RightStepX);

      CurrRightTextX:=Poly^[vrtx1].u;
      CurrRightTextY:=Poly^[vrtx1].v;
      RightTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrRightTextX,height);
      RightTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrRightTextY,height);

      RightColor:=Poly^[vrtx1].color;
      RightColorStep:=mFixedDiv(Poly^[vrtx2].color-RightColor,height);
      RightColor+:=BaseColor;
  end;

var hsize:longint;
--    width:fixed;
    temp:fixed;
    x:fixed;
    XFracStep,ColorStepInv:fixed;
Begin
   asm
 --  BaseColor:=color*65536; -- translate base color into 16.16 fixed
       movsx eax,color
 --  MinY:= 2140000000;
       mov edi,2140000000
       sal eax,16
 --  MaxY:=-2140000000;
       mov ebx,-2140000000
       mov BaseColor,eax

       mov ecx,1
       mov esi,Poly

{ scan for max&min vertexes}
--   for n:=1 to Num do begin
   @@ScanVertex:
--      temp:=Poly^[n].y;
       mov edx,[esi][4]
--      if temp<MinY then begin
       cmp edx,edi
       jge @@Above
--         MinY:=temp;
         mov edi,edx
--         MinVrtx:=n
         mov al,cl
--      end;
      @@Above:
--      if temp>MaxY then begin
       cmp edx,ebx
       jle @@Bellow
--         MaxY:=temp;
         mov ebx,edx
--         MaxVrtx:=n
         mov ah,cl
--      end;
      @@Bellow:
       inc ecx
       add esi,TYPE(TVertex3dFix)
       cmp cl,num
       jng @@ScanVertex
--   end;

--   LeftVrtx:=MinVrtx;  {left side starting vertex}
--   RightVrtx:=MinVrtx;
     mov byte ptr LeftVrtx,al
     mov byte ptr RightVrtx,al
     mov byte ptr MaxVrtx,ah

--   CurrY:=mRound(MinY);
     mov eax,edi
     sar eax,16
     adc eax,0

--   offs:=CurrY*Where.SizeX;
     movzx edx,Where.SizeX
     mul edx
     mov offs,eax

--   while LeftSectionSize<=0 do begin
@@WaitForLeftSection1:
--   if LeftVrtx=MaxVrtx then exit;
       mov ax,MaxVrtx
       cmp ax,LeftVrtx
       jne @@ScanLeft
          jmp @@escape
  @@ScanLeft:

   {search for first usable left & right sections}
--     LeftSection
       call LeftSection
       cmp LeftSectionSize,0
       jle @@WaitForLeftSection1
--   end;

--   while RightSectionSize<=0 do begin
@@WaitForRightSection1:
--   if RightVrtx=MaxVrtx then exit;
       mov ax,MaxVrtx
       cmp ax,RightVrtx
       jne @@ScanRight
          jmp @@escape
  @@ScanRight:

--     RightSection
       call RightSection
       cmp RightSectionSize,0
       jle @@WaitForRightSection1
--   end;


@@MainLoop:
     -- x:=mRound(CurrLeftX);
     mov edx,CurrLeftX
     mov ecx,edx
     shr edx,16
     adc edx,0
     mov x,edx
     -- hsize:=mRound(CurrRightX)-x;
     mov ebx,CurrRightX
     mov eax,ebx
     shr eax,16
     adc eax,0
     sub eax,edx
     cmp eax,0
  jle @@ZeroWidth        -- if hSize>0 then begin

     mov hsize,eax
     -- width:=CurrRightX-CurrLeftX
     sub ebx,ecx

     --TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
     mov edx,CurrRightTextX
     sub edx,CurrLeftTextX
     shrd eax,edx,16
     sar edx,16
     idiv ebx
     mov TextStepX,eax
     ---------------
     -- modify constants in inner loop
     lea edi,@@Mod1-4
     shl eax,16
     mov [edi],eax
     ---------------
     --ColorStep:=mFixedDiv(RightColor-LeftColor,width);
     mov edx,RightColor
     sub edx,LeftColor
     shrd eax,edx,16
     sar edx,16
     idiv ebx
     mov ColorStep,eax
     --------------
     -- modify constants in inner loop
     ror eax,16
     lea edi,@@mod2-4
     mov [edi],eax
     lea edi,@@mod3-1
     mov [edi],al
     -------------
     --TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);
     mov edx,CurrRightTextY
     sub edx,CurrLeftTextY
     shrd eax,edx,16
     sar edx,16
     idiv ebx
     mov TextStepY,eax

{************ INNER LOOP BEGINS HERE **********************}
         mov ebx,dword ptr Txt  -- get texture pointer
         mov ecx,hsize

         mov bl,byte ptr [CurrLeftTextX+2]
         mov edx,CurrLeftTextY
         mov bh,byte ptr [CurrLeftTextY+2]
         shl edx,16

         mov eax,TextStepX
         mov dl,byte ptr [TextStepX+2]
         shl eax,16
         mov dh,byte ptr [TextStepY+2]
         mov XFracStep,eax

         mov eax,ColorStep
         mov esi,LeftColor
         ror eax,16
         ror esi,16
         mov ColorStepInv,eax
         mov eax,CurrLeftTextX
         mov edi,dword ptr Where  -- get destination pointer
         shl eax,16
         add edi,offs
         mov ah,byte ptr [LeftColor+2]
         add edi,x

         push ebp
         mov ebp,TextStepY
         lea edi,[edi+ecx]
         shl ebp,16

         xor ecx,-1
         inc ecx
    @@inner:
         add edx,ebp                         -- yfrac+:=yfrac_step
         mov al,[ebx]
         adc bh,dh                           -- yint+:=yint_step
         add eax,123456--XFracStep           -- xfrac+:=xfrac_step
@@Mod1:
         adc bl,dl                           -- xint+:=xint_step
         add esi,123456--ColorStepInv        -- colorfrac+:=colorfrac_step
@@Mod2:
         adc ah,123--byte ptr ColorStepInv   -- colorint+:=colorint_step
@@Mod3:
         add al,ah                           -- TextColor+:=ColoInt
         mov [edi+ecx],al
         inc ecx
         jnz @@inner
         pop ebp
{************ INNER LOOP ENDS HERE **********************}
  @@ZeroWidth:
     --offs+:=Where.SizeX;
     mov eax,offs
     movzx edx,Where.SizeX
     add eax,edx
     mov offs,eax

     --LeftSectionSize-:=1;
     --RightSectionSize-:=1;
     mov eax,RightSectionSize
     mov edx,LeftSectionSize
     dec eax
     dec edx
     mov RightSectionSize,eax
     mov LeftSectionSize,edx

     --if LeftSectionSize<=0 then
     cmp edx,0
     jg @@LeftSectionOK
       -- while LeftSectionSize<=0 do begin
   @@WaitForLeftSection:
            --if LeftVrtx=MaxVrtx then exit;
         mov ax,LeftVrtx
         cmp ax,MaxVrtx
         jne @@GoAhead1
           --ret
           jmp @@escape
     @@GoAhead1:
         --LeftSection
         call LeftSection
         cmp LeftSectionSize,0
         jle @@WaitForLeftSection
         jmp @@ScanRightSection
       -- end
     -- else begin
   @@LeftSectionOK:
      --CurrLeftX+:=LeftStepX;
      mov eax,CurrLeftX
      mov edx,LeftStepX
      --CurrLeftTextX+:=LeftTextStepX;
      mov ebx,CurrLeftTextX
      mov ecx,LeftTextStepX
      add eax,edx
      add ebx,ecx
      mov CurrLeftX,eax
      mov CurrLeftTextX,ebx
      --CurrLeftTextY+:=LeftTextStepY;
      mov eax,CurrLeftTextY
      mov edx,LeftTextStepY
      --LeftColor+:=LeftColorStep;
      mov ebx,LeftColor
      mov ecx,LeftColorStep
      add eax,edx
      add ebx,ecx
      mov CurrLeftTextY,eax
      mov LeftColor,ebx
   --end;
@@ScanRightSection:
     cmp RightSectionSize,0
     jg @@RightSectionOK
       -- while RightSectionSize<=0 do begin
   @@WaitForRightSection:
            --if RightVrtx=MaxVrtx then exit;
         mov ax,RightVrtx
         cmp ax,MaxVrtx
         jne @@GoAhead2
           --ret
           jmp @@escape
     @@GoAhead2:
         --RightSection
         call RightSection
         cmp RightSectionSize,0
         jle @@WaitForRightSection
         --jmp @@ScanRightSection
         jmp @@MainLoop
       -- end
     -- else begin
   @@RightSectionOK:
      --CurrRightX+:=RightStepX;
      mov eax,CurrRightX
      mov edx,RightStepX
      --CurrRightTextX+:=RightTextStepX;
      mov ebx,CurrRightTextX
      mov ecx,RightTextStepX
      add eax,edx
      add ebx,ecx
      mov CurrRightX,eax
      mov CurrRightTextX,ebx
      --CurrRightTextY+:=RightTextStepY;
      mov eax,CurrRightTextY
      mov edx,RightTextStepY
      --RightColor+:=RightColorStep;
      mov ebx,RightColor
      mov ecx,RightColorStep
      add eax,edx
      add ebx,ecx
      mov CurrRightTextY,eax
      mov RightColor,ebx
   --end;

--until false;
   jmp @@MainLoop
@@escape:
  end;
end;
