(*************************************************************)
(*                                                           *)
(*         Types definitions for SVGALIB                     *)
(*                                                           *)
(*************************************************************)
TYPE
 TVbeInfo = record
  VbeSignature       : array[1..4] of char;
  VbeVersion         : Word;
  OemStringPtr       : dword;
  Capabilities       : dword;
  VideoModePtr       : dword;
  TotalMemory        : Word;
  OEMSoftwareRev     : Word;
  OEMVendorNamePtr   : dword;
  OEMProductNamePtr  : dword;
  OEMProductRevPtr   : dword;
  Reserved           : array [0..221] of Byte;
  OEMData            : array [0..255] of Byte;
 end;

 (* VBE mode info block structure *)
 TVbeModeInfo = record
  ModeAttributes     : Word;
  WinAAttributes     : Byte;
  WinBAttributes     : Byte;
  WinGranularity     : Word;
  WinSize            : Word;
  WinASegment        : Word;
  WinBSegment        : Word;
  WinFuncPtr         : Pointer;
  BytesPerScanLine   : Word;
  XResolution        : Word;
  YResolution        : Word;
  XCharSize          : Byte;
  YCharSize          : Byte;
  NumberOfPlanes     : Byte;
  BitsPerPixel       : Byte;
  NumberOfBanks      : Byte;
  MemoryModel        : Byte;
  BankSize           : Byte;
  NumberOfImagePages : Byte;
  Reserved           : Byte;
  RedMaskSize        : Byte;
  RedFieldPosition   : Byte;
  GreenMaskSize      : Byte;
  GreenFieldPosition : Byte;
  BlueMaskSize       : Byte;
  BlueFieldPosition  : Byte;
  RsvdMaskSize       : Byte;
  RsvdFieldPosition  : Byte;
  DirectColorModeInfo: Byte;
  PhysBasePtr        : DWord;
  OffScreenMemOffset : DWord;
  OffScreenMemSize   : Word;
  Reserved2          : Array [0..205] of Byte;
 end;

 TShortModeInfo=record
    ModeNumber:word;
    xRes,yRes:word;
    BitsPerPixel:byte;
    ModeAttributes:word;
 end;
 TModesInfoList=array[1..50] of TShortModeInfo;
 { render surface type }
 TPageType=record
              seg:dword;
              SizeX,SizeY:word;
           end;

{ Constants and Types for SVGA texture engine}
 Const
    maxvertex=4;
    NoShading     =0;
    GoraudShading =1;
    LambertShading=2;
 Type
    TVertex3dFix=record
                  x,y,z,  {coordinates in 16.16 fixed point numbers}
                  u,v,    {u,v-texture x & y coordinates}
                  color:fixed   {color - color value}
                 end;

{internal types for polygon filling and texture routines}
    TPolygonVrtx=array[1..255] of TVertex3dFix;
    TPolygonPtr =^TPolygonVrtx;
    TScreen     =array[0..$0FFFFFF] of byte;
    TPalette    =array[0..255] of word;
{end of internal types}

    TPoly =array[1..maxvertex] of TVertex3dFix;

    TTexture   =record
                  txt:^TScreen;
                  SizeX:integer;
               {this field is used for texture rendering in 15/16 bit modes}
                  Pal:^TPalette;
                end;

    TRGBColor  =record
                  b,g,r:byte
                end;

    TTranspTable=array[0..255,0..255] of byte;
    TTranspTablePtr=^TTranspTable;

    TMousePointer=record
                    Buf:^TScreen;       {pointer to linear mouse buffer}
                    SizeX,SizeY:integer;
                    TranspColor:byte;   {color that must be transparent}
                    {pointer to buffer for background storing}
                    {for internal use only!!}
                    BKBuf:^TScreen;
                  end;

{ constants for mouse handler settings }
Const
   MovingOnly=1;
   AnyEvent  =$7F;